// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/auth.proto

package org.apache.ratis.thirdparty.com.google.api;

/**
 * <pre>
 * OAuth scopes are a way to define data and permissions on data. For example,
 * there are scopes defined for "Read-only access to Google Calendar" and
 * "Access to Cloud Platform". Users can consent to a scope for an application,
 * giving it permission to access that data on their behalf.
 * OAuth scope specifications should be fairly coarse grained; a user will need
 * to see and understand the text description of what your scope means.
 * In most cases: use one or at most two OAuth scopes for an entire family of
 * products. If your product has multiple APIs, you should probably be sharing
 * the OAuth scope across all of those APIs.
 * When you need finer grained OAuth consent screens: talk with your product
 * management about how developers will use them in practice.
 * Please note that even though each of the canonical scopes is enough for a
 * request to be accepted and passed to the backend, a request can still fail
 * due to the backend requiring additional scopes or permissions.
 * </pre>
 *
 * Protobuf type {@code google.api.OAuthRequirements}
 */
public  final class OAuthRequirements extends
    org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:google.api.OAuthRequirements)
    OAuthRequirementsOrBuilder {
private static final long serialVersionUID = 0L;
  // Use OAuthRequirements.newBuilder() to construct.
  private OAuthRequirements(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private OAuthRequirements() {
    canonicalScopes_ = "";
  }

  @Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private OAuthRequirements(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new NullPointerException();
    }
    int mutable_bitField0_ = 0;
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            String s = input.readStringRequireUtf8();

            canonicalScopes_ = s;
            break;
          }
          default: {
            if (!parseUnknownField(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return AuthProto.internal_static_google_api_OAuthRequirements_descriptor;
  }

  @Override
  protected FieldAccessorTable
      internalGetFieldAccessorTable() {
    return AuthProto.internal_static_google_api_OAuthRequirements_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            OAuthRequirements.class, Builder.class);
  }

  public static final int CANONICAL_SCOPES_FIELD_NUMBER = 1;
  private volatile Object canonicalScopes_;
  /**
   * <pre>
   * The list of publicly documented OAuth scopes that are allowed access. An
   * OAuth token containing any of these scopes will be accepted.
   * Example:
   *      canonical_scopes: https://www.googleapis.com/auth/calendar,
   *                        https://www.googleapis.com/auth/calendar.read
   * </pre>
   *
   * <code>string canonical_scopes = 1;</code>
   */
  public String getCanonicalScopes() {
    Object ref = canonicalScopes_;
    if (ref instanceof String) {
      return (String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = 
          (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      String s = bs.toStringUtf8();
      canonicalScopes_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * The list of publicly documented OAuth scopes that are allowed access. An
   * OAuth token containing any of these scopes will be accepted.
   * Example:
   *      canonical_scopes: https://www.googleapis.com/auth/calendar,
   *                        https://www.googleapis.com/auth/calendar.read
   * </pre>
   *
   * <code>string canonical_scopes = 1;</code>
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString
      getCanonicalScopesBytes() {
    Object ref = canonicalScopes_;
    if (ref instanceof String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b = 
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8(
              (String) ref);
      canonicalScopes_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  private byte memoizedIsInitialized = -1;
  @Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getCanonicalScopesBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, canonicalScopes_);
    }
    unknownFields.writeTo(output);
  }

  @Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getCanonicalScopesBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, canonicalScopes_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @Override
  public boolean equals(final Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof OAuthRequirements)) {
      return super.equals(obj);
    }
    OAuthRequirements other = (OAuthRequirements) obj;

    if (!getCanonicalScopes()
        .equals(other.getCanonicalScopes())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + CANONICAL_SCOPES_FIELD_NUMBER;
    hash = (53 * hash) + getCanonicalScopes().hashCode();
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static OAuthRequirements parseFrom(
      java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static OAuthRequirements parseFrom(
      java.nio.ByteBuffer data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static OAuthRequirements parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static OAuthRequirements parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static OAuthRequirements parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static OAuthRequirements parseFrom(
      byte[] data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static OAuthRequirements parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static OAuthRequirements parseFrom(
      java.io.InputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static OAuthRequirements parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static OAuthRequirements parseDelimitedFrom(
      java.io.InputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static OAuthRequirements parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static OAuthRequirements parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(OAuthRequirements prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @Override
  protected Builder newBuilderForType(
      BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * OAuth scopes are a way to define data and permissions on data. For example,
   * there are scopes defined for "Read-only access to Google Calendar" and
   * "Access to Cloud Platform". Users can consent to a scope for an application,
   * giving it permission to access that data on their behalf.
   * OAuth scope specifications should be fairly coarse grained; a user will need
   * to see and understand the text description of what your scope means.
   * In most cases: use one or at most two OAuth scopes for an entire family of
   * products. If your product has multiple APIs, you should probably be sharing
   * the OAuth scope across all of those APIs.
   * When you need finer grained OAuth consent screens: talk with your product
   * management about how developers will use them in practice.
   * Please note that even though each of the canonical scopes is enough for a
   * request to be accepted and passed to the backend, a request can still fail
   * due to the backend requiring additional scopes or permissions.
   * </pre>
   *
   * Protobuf type {@code google.api.OAuthRequirements}
   */
  public static final class Builder extends
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:google.api.OAuthRequirements)
      org.apache.ratis.thirdparty.com.google.api.OAuthRequirementsOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return AuthProto.internal_static_google_api_OAuthRequirements_descriptor;
    }

    @Override
    protected FieldAccessorTable
        internalGetFieldAccessorTable() {
      return AuthProto.internal_static_google_api_OAuthRequirements_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              OAuthRequirements.class, Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.api.OAuthRequirements.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    @Override
    public Builder clear() {
      super.clear();
      canonicalScopes_ = "";

      return this;
    }

    @Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return AuthProto.internal_static_google_api_OAuthRequirements_descriptor;
    }

    @Override
    public OAuthRequirements getDefaultInstanceForType() {
      return OAuthRequirements.getDefaultInstance();
    }

    @Override
    public OAuthRequirements build() {
      OAuthRequirements result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @Override
    public OAuthRequirements buildPartial() {
      OAuthRequirements result = new OAuthRequirements(this);
      result.canonicalScopes_ = canonicalScopes_;
      onBuilt();
      return result;
    }

    @Override
    public Builder clone() {
      return super.clone();
    }
    @Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
        Object value) {
      return super.setField(field, value);
    }
    @Override
    public Builder clearField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }
    @Override
    public Builder clearOneof(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }
    @Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, Object value) {
      return super.setRepeatedField(field, index, value);
    }
    @Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
        Object value) {
      return super.addRepeatedField(field, value);
    }
    @Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof OAuthRequirements) {
        return mergeFrom((OAuthRequirements)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(OAuthRequirements other) {
      if (other == OAuthRequirements.getDefaultInstance()) return this;
      if (!other.getCanonicalScopes().isEmpty()) {
        canonicalScopes_ = other.canonicalScopes_;
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @Override
    public final boolean isInitialized() {
      return true;
    }

    @Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      OAuthRequirements parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (OAuthRequirements) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private Object canonicalScopes_ = "";
    /**
     * <pre>
     * The list of publicly documented OAuth scopes that are allowed access. An
     * OAuth token containing any of these scopes will be accepted.
     * Example:
     *      canonical_scopes: https://www.googleapis.com/auth/calendar,
     *                        https://www.googleapis.com/auth/calendar.read
     * </pre>
     *
     * <code>string canonical_scopes = 1;</code>
     */
    public String getCanonicalScopes() {
      Object ref = canonicalScopes_;
      if (!(ref instanceof String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs =
            (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        canonicalScopes_ = s;
        return s;
      } else {
        return (String) ref;
      }
    }
    /**
     * <pre>
     * The list of publicly documented OAuth scopes that are allowed access. An
     * OAuth token containing any of these scopes will be accepted.
     * Example:
     *      canonical_scopes: https://www.googleapis.com/auth/calendar,
     *                        https://www.googleapis.com/auth/calendar.read
     * </pre>
     *
     * <code>string canonical_scopes = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString
        getCanonicalScopesBytes() {
      Object ref = canonicalScopes_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b = 
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        canonicalScopes_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * The list of publicly documented OAuth scopes that are allowed access. An
     * OAuth token containing any of these scopes will be accepted.
     * Example:
     *      canonical_scopes: https://www.googleapis.com/auth/calendar,
     *                        https://www.googleapis.com/auth/calendar.read
     * </pre>
     *
     * <code>string canonical_scopes = 1;</code>
     */
    public Builder setCanonicalScopes(
        String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      canonicalScopes_ = value;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The list of publicly documented OAuth scopes that are allowed access. An
     * OAuth token containing any of these scopes will be accepted.
     * Example:
     *      canonical_scopes: https://www.googleapis.com/auth/calendar,
     *                        https://www.googleapis.com/auth/calendar.read
     * </pre>
     *
     * <code>string canonical_scopes = 1;</code>
     */
    public Builder clearCanonicalScopes() {
      
      canonicalScopes_ = getDefaultInstance().getCanonicalScopes();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The list of publicly documented OAuth scopes that are allowed access. An
     * OAuth token containing any of these scopes will be accepted.
     * Example:
     *      canonical_scopes: https://www.googleapis.com/auth/calendar,
     *                        https://www.googleapis.com/auth/calendar.read
     * </pre>
     *
     * <code>string canonical_scopes = 1;</code>
     */
    public Builder setCanonicalScopesBytes(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      canonicalScopes_ = value;
      onChanged();
      return this;
    }
    @Override
    public final Builder setUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:google.api.OAuthRequirements)
  }

  // @@protoc_insertion_point(class_scope:google.api.OAuthRequirements)
  private static final OAuthRequirements DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new OAuthRequirements();
  }

  public static OAuthRequirements getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<OAuthRequirements>
      PARSER = new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<OAuthRequirements>() {
    @Override
    public OAuthRequirements parsePartialFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return new OAuthRequirements(input, extensionRegistry);
    }
  };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<OAuthRequirements> parser() {
    return PARSER;
  }

  @Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<OAuthRequirements> getParserForType() {
    return PARSER;
  }

  @Override
  public OAuthRequirements getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

